"""
This module contains functionality for managing resources on
the PacketLogic system.

Do NOT import this module directly. The L{PLConnection
<packetlogic2.PLConnection>} object should be used, e.g:

    >>> import packetlogic2
    >>> pl = packetlogic2.connect("192.168.1.25", "admin", "pldemo00")
    >>> re = pl.ResourceEdit()

@var __revision__: Revision identifier.
"""

__revision__ = '%K%'

from resource import Resource
from thisversion import PLDB

import plutil

class ResourceEdit(Resource):
    """
    This is the resource for manipulating resources

    @group ResourceEdit: list,steal
    """
    def _resource(self):
        return PLDB.RESOURCE_RESOURCE

    def list(self):
        """
        List resources and their configuration

        @rtype: list of dict
	"""    
	return plutil._do(self, self.session.resource_resource_list(), plutil._ListCB(self, self.session.resource_resource_list_handle, None, False))

    def steal(self, resid):
        """
        Break the lock of a locked resource.
	"""
        cid = self.session.resource_resource_steal(resid)
	return plutil._do(self, cid, plutil._Callback(self))
