#!/usr/bin/python

""" If you run this file it will overwrite itself with the 'PROTOCOLS = ...' line
replaced with data taken from the /etc/protocols file.

You can import this file (from protocols import PROTOCOLS) if you wish to have
a translation between name and number on IP protocols. The dictionary goes both
ways, e.g PROTOCOLS['tcp'] == 6 and PROTOCOLS[6] == 'tcp'.
"""

PROTOCOLS = {0: 'ip', 1: 'icmp', 2: 'igmp', 3: 'ggp', 4: 'ipencap', 5: 'st', 6: 'tcp', 8: 'egp', 9: 'igp', 12: 'pup', 'tcp': 6, 17: 'udp', 20: 'hmp', 22: 'xns-idp', 27: 'rdp', 29: 'iso-tp4', 36: 'xtp', 37: 'ddp', 38: 'idpr-cmtp', 'xtp': 36, 41: 'ipv6', 43: 'ipv6-route', 44: 'ipv6-frag', 45: 'idrp', 46: 'rsvp', 47: 'gre', 50: 'esp', 51: 'ah', 'ipcomp': 108, 'skip': 57, 57: 'skip', 58: 'ipv6-icmp', 59: 'ipv6-nonxt', 60: 'ipv6-opts', 'ipencap': 4, 'rsvp': 46, 73: 'rspf', 81: 'vmtp', 88: 'eigrp', 89: 'ospf', 93: 'ax.25', 94: 'ipip', 97: 'etherip', 98: 'encap', 103: 'pim', 108: 'ipcomp', 112: 'vrrp', 115: 'l2tp', 124: 'isis', 132: 'sctp', 133: 'fc', 'esp': 50, 'ddp': 37, 'ax.25': 93, 'xns-idp': 22, 'vrrp': 112, 'sctp': 132, 'idpr-cmtp': 38, 'ipv6-route': 43, 'ggp': 3, 'pup': 12, 'rdp': 27, 'idrp': 45, 'ospf': 89, 'vmtp': 81, 'igmp': 2, 'iso-tp4': 29, 'ipv6-icmp': 58, 'l2tp': 115, 'ah': 51, 'udp': 17, 'ipv6': 41, 'hmp': 20, 'ipv6-opts': 60, 'icmp': 1, 'isis': 124, 'ipip': 94, 'eigrp': 88, 'pim': 103, 'ip': 0, 'igp': 9, 'gre': 47, 'encap': 98, 'rspf': 73, 'fc': 133, 'etherip': 97, 'ipv6-nonxt': 59, 'egp': 8, 'st': 5, 'ipv6-frag': 44}

if __name__ == '__main__':
	pline = 'PROTOCOLS = %s\n' % repr(dict(reduce(lambda z,x: z.extend(x) or z,[[(int(p[1]),p[0]),(p[0],int(p[1]))] for p in [r[:r.index('#')].strip().split(None,2) for r in [x.strip()+'#' for x in file('/etc/protocols')] if not r.startswith('#')]],[])))
	lines = [[r, pline][r.startswith('PROTOCOLS')] for r in file(__file__)]
	file(__file__, 'w').write("".join(lines))
	print "Wrote %d lines to %s." % (len(lines), __file__)
